"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const observable_1 = require("@reactive-js/observable");
exports.fromEvent = (target, eventName, selector) => observable_1.createObservable(subscriber => {
    const listener = (event) => {
        try {
            const result = selector(event);
            subscriber.dispatch(result);
        }
        catch (cause) {
            subscriber.dispose({ cause });
        }
    };
    target.addEventListener(eventName, listener, { passive: true });
    subscriber.add(() => {
        target.removeEventListener(eventName, listener);
    });
});
//# sourceMappingURL=event.js.map